/**
 * Copyright 2005 Jason LaDere
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Originally based on Project64 code.
 *
 */

/*
 * OpenGl.java
 *
 * Created on November 26, 2005, 8:06 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package gln64j;

import gln64j.rsp.Gsp;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.nio.FloatBuffer;
import javax.swing.JFrame;
import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLEventListener;

/**
 *
 * @author Jason
 */
public class OpenGl {
    
//    private static final int SIZEOF_FLOAT = 4;
//    private static final int SIZEOF_GLVERTEX = 17 * SIZEOF_FLOAT;
    
    private static class GLVertex {
        public FloatBuffer vtx; // 4
        public FloatBuffer color; // 4
        public FloatBuffer secondaryColor; // 4
        public FloatBuffer tex0; // 2
        public FloatBuffer tex1; // 2
        public FloatBuffer fog; // 1
        
        public GLVertex() { }
        
        public GLVertex(float x, float y, float z, float w,
                float r1, float g1, float b1, float a1,
                float r2, float g2, float b2, float a2,
                float s0, float t0, float s1, float t1, float f) {
            vtx = FloatBuffer.allocate(4);
            vtx.put(x);
            vtx.put(y);
            vtx.put(z);
            vtx.put(w);
            color = FloatBuffer.allocate(4);
            color.put(r1);
            color.put(g1);
            color.put(b1);
            color.put(a1);
            secondaryColor = FloatBuffer.allocate(4);
            secondaryColor.put(r2);
            secondaryColor.put(g2);
            secondaryColor.put(b2);
            secondaryColor.put(a2);
            tex0 = FloatBuffer.allocate(2);
            tex0.put(s0);
            tex0.put(t0);
            tex1 = FloatBuffer.allocate(2);
            tex1.put(s1);
            tex1.put(t1);
            fog = FloatBuffer.allocate(1);
            fog.put(f);
        }
    };
    
    private static class OGL_EventListener implements GLEventListener {

        public void init(GLAutoDrawable gLDrawable) {
            gl = gLDrawable.getGL();
//            OpenGlGdp.gl = gl;
//            
//            for (int i = 0; i < 256; i++)
//                OpenGlGdp.vertices[i] = new OpenGlGdp.GLVertex();
//            bigArray = BufferUtil.newFloatBuffer(256 * 17);
//            for (int i = 0; i < 256; i++) {
//                bigArray.position(i * 17);
//                OpenGlGdp.vertices[i].vtx = bigArray.slice();
//                bigArray.position(i * 17 + 4);
//                OpenGlGdp.vertices[i].color = bigArray.slice();
//                bigArray.position(i * 17 + 8);
//                OpenGlGdp.vertices[i].secondaryColor = bigArray.slice();
//                bigArray.position(i * 17 + 12);
//                OpenGlGdp.vertices[i].tex0 = bigArray.slice();
//                bigArray.position(i * 17 + 14);
//                OpenGlGdp.vertices[i].tex1 = bigArray.slice();
//                bigArray.position(i * 17 + 16);
//                OpenGlGdp.vertices[i].fog = bigArray.slice();
//            }
//            
//            if (Debug.DEBUG_OGL) System.out.println("GL_NV_register_combiners: " + OpenGlGdp.NV_register_combiners);
//            OpenGlGdp.ARB_multitexture = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_ARB_multitexture");
//            if (Debug.DEBUG_OGL) System.out.println("GL_ARB_multitexture: " + OpenGlGdp.ARB_multitexture);
//            if (OpenGlGdp.ARB_multitexture) {
//                int[] maxTextureUnits_t = new int[1];
//                gl.glGetIntegerv(GL.GL_MAX_TEXTURE_UNITS, maxTextureUnits_t, 0);
//                OpenGlGdp.maxTextureUnits = StrictMath.min(8, maxTextureUnits_t[0]); // The plugin only supports 8, and 4 is really enough
//            }
//            EXT_fog_coord = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_EXT_fog_coord");
//            if (Debug.DEBUG_OGL) System.out.println("GL_EXT_fog_coord: " + EXT_fog_coord);
//            OpenGlGdp.EXT_secondary_color = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_EXT_secondary_color");
//            if (Debug.DEBUG_OGL) System.out.println("GL_EXT_secondary_color: " + OpenGlGdp.EXT_secondary_color);
//            OpenGlGdp.ARB_texture_env_combine = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_ARB_texture_env_combine");
//            if (Debug.DEBUG_OGL) System.out.println("GL_ARB_texture_env_combine: " + OpenGlGdp.ARB_texture_env_combine);
//            OpenGlGdp.ARB_texture_env_crossbar = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_ARB_texture_env_crossbar");
//            if (Debug.DEBUG_OGL) System.out.println("GL_ARB_texture_env_crossbar: " + OpenGlGdp.ARB_texture_env_crossbar);
//            OpenGlGdp.EXT_texture_env_combine = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_EXT_texture_env_combine");
//            if (Debug.DEBUG_OGL) System.out.println("GL_EXT_texture_env_combine: " + OpenGlGdp.EXT_texture_env_combine);
//            OpenGlGdp.ATI_texture_env_combine3 = gl.glGetString(GL.GL_EXTENSIONS).contains("GL_ATI_texture_env_combine3");
//            if (Debug.DEBUG_OGL) System.out.println("GL_ATI_texture_env_combine3: " + OpenGlGdp.ATI_texture_env_combine3);
//            if (Debug.DEBUG_OGL) System.out.println("GL_ATIX_texture_env_route: " + OpenGlGdp.ATIX_texture_env_route);
//            if (Debug.DEBUG_OGL) System.out.println("GL_NV_texture_env_combine4: " + OpenGlGdp.NV_texture_env_combine4);
//            
//            gl.glMatrixMode(GL.GL_PROJECTION);
//            gl.glLoadIdentity();
//            gl.glMatrixMode(GL.GL_MODELVIEW);
//            gl.glLoadIdentity();
//            bigArray.position(0);
//            gl.glVertexPointer(4, GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//            gl.glEnableClientState(GL.GL_VERTEX_ARRAY);
//            bigArray.position(4);
//            gl.glColorPointer(4, GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//            gl.glEnableClientState(GL.GL_COLOR_ARRAY);
//            if (OpenGlGdp.EXT_secondary_color) {
//                bigArray.position(8);
//                gl.glSecondaryColorPointerEXT(3, GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//                gl.glEnableClientState(GL.GL_SECONDARY_COLOR_ARRAY_EXT);
//            }
//            if (OpenGlGdp.ARB_multitexture) {
//                gl.glClientActiveTexture(GL.GL_TEXTURE0);
//                bigArray.position(12);
//                gl.glTexCoordPointer(2, GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//                gl.glEnableClientState(GL.GL_TEXTURE_COORD_ARRAY);
//                gl.glClientActiveTexture(GL.GL_TEXTURE1);
//                bigArray.position(14);
//                gl.glTexCoordPointer(2, GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//                gl.glEnableClientState(GL.GL_TEXTURE_COORD_ARRAY);
//            } else {
//                bigArray.position(12);
//                gl.glTexCoordPointer(2, GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//                gl.glEnableClientState(GL.GL_TEXTURE_COORD_ARRAY);
//            }
//            if (EXT_fog_coord) {
//                gl.glFogi(GL.GL_FOG_COORDINATE_SOURCE_EXT, GL.GL_FOG_COORDINATE_EXT);
//                gl.glFogi(GL.GL_FOG_MODE, GL.GL_LINEAR);
//                gl.glFogf(GL.GL_FOG_START, 0.0f);
//                gl.glFogf(GL.GL_FOG_END, 255.0f);
//                bigArray.position(16);
//                gl.glFogCoordPointerEXT(GL.GL_FLOAT, SIZEOF_GLVERTEX, bigArray.slice());
//                gl.glEnableClientState(GL.GL_FOG_COORDINATE_ARRAY_EXT);
//            }
//            gl.glPolygonOffset(-3.0f, -3.0f);
//            gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
//            gl.glClear(GL.GL_COLOR_BUFFER_BIT);
            
            OpenGlGdp.init(gl);
            
            Rsp.gsp.changed = Rsp.gdp.changed = 0xFFFFFFFF;
//            OpenGlGdp.OGL_UpdateScale();
        }
        
        public void display(GLAutoDrawable gLDrawable) {
            try {
                OpenGlGdp.VI_UpdateSize();
                OpenGlGdp.OGL_UpdateScale();

//                Rsp.gdp.otherMode.w1 &= ~0x3;
                Rsp.gdp.gDPSetAlphaCompare(Gbi.G_AC_NONE); // 0
                Rsp.gdp.gDPSetDepthSource(Gbi.G_ZS_PIXEL); // 0

                Rsp.gdp.gDPSetRenderMode(0, 0);

//                Rsp.gdp.otherMode.w0 = (Rsp.gdp.otherMode.w0 & 15) | (3 << 4) | (3 << 6) | (6 << 9) | (1 << 19);
                Rsp.gdp.gDPSetAlphaDither(Gbi.G_AD_DISABLE); // 3
                Rsp.gdp.gDPSetColorDither(Gbi.G_CD_DISABLE); // 3
                Rsp.gdp.gDPSetCombineKey(Gbi.G_CK_NONE); // 0
                Rsp.gdp.gDPSetTextureConvert(Gbi.G_TC_FILT); // 6
                Rsp.gdp.gDPSetTextureFilter(Gbi.G_TF_POINT); // 0
                Rsp.gdp.gDPSetTextureLUT(Gbi.G_TT_NONE); // 0
                Rsp.gdp.gDPSetTextureLOD(Gbi.G_TL_TILE); // 0
                Rsp.gdp.gDPSetTextureDetail(Gbi.G_TD_CLAMP); // 0
                Rsp.gdp.gDPSetTexturePersp(Gbi.G_TP_PERSP); // 1
                Rsp.gdp.gDPSetCycleType(Gbi.G_CYC_1CYCLE); // 0
                Rsp.gdp.gDPPipelineMode(Gbi.G_PM_NPRIMITIVE); // 0

                Rsp.gsp.loadUcode(uc_start, uc_dstart);
                Rsp.gsp.RSP_ProcessDList();
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        
        public void reshape(GLAutoDrawable gLDrawable, int i, int i0, int i1, int i2) {
        }
        
        public void displayChanged(GLAutoDrawable gLDrawable, boolean b, boolean b0) {
        }
        
    };
    
    public static GL gl;
    
    public static int uc_start;
    public static int uc_dstart;
    
//    public static boolean	EXT_fog_coord;			// TNT, GeForce, Rage 128, Radeon
    
    // used by Gsp
//    public static int numTriangles;
//
//    private static GLVertex[] vertices = new GLVertex[256];
//    private static int numVertices;
    private static boolean fog;
//    private static FloatBuffer bigArray;
    
    /** Creates a new instance of OpenGl */
    private OpenGl() {
    }
    
    // called by GLN64Plugin
    public static void config() {
        fog = false; //true;
        OpenGlGdp.config();
    }
    
    // called by GLN64Plugin
    public static void OGL_Stop() {
//        if (Debug.DEBUG_TEXTURES) {
//            System.out.printf("Texture Cache Hits: %d\n", CachedTextureActions.cache.hits);
//            System.out.printf("Texture Cache Misses: %d\n", CachedTextureActions.cache.misses);
//        }
    }
    
    // called by GLN64jPlugin
    public static boolean OGL_Start() {
        int displayWidth = 640;
        int displayHeight = 480;
//        boolean fullscreen = false;
//        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
//        GraphicsDevice device = env.getDefaultScreenDevice();
        JFrame window = GLN64jPlugin.hWnd;
        GLCanvas canvas = new GLCanvas();
//        if (Debug.DEBUG_OGL)
//            canvas.setGL(new DebugGL(canvas.getGL())); // DEBUG
        canvas.setIgnoreRepaint(true);
        canvas.setAutoSwapBufferMode(false);
        canvas.addGLEventListener(new OGL_EventListener());
        window.getContentPane().removeAll();
        window.getContentPane().add(canvas);
        canvas.setSize(displayWidth, displayHeight);
//        if (fullscreen) {
//            DisplayMode displayMode = new DisplayMode(displayWidth, displayHeight, 32, 60);
//            window.setUndecorated(true);
//            window.setResizable(false);
//            device.setFullScreenWindow(window);
//            if (device.isFullScreenSupported())
//                device.setDisplayMode(displayMode);
//            window.setLocation(0, 0);
//            window.setSize(displayMode.getWidth(), displayMode.getHeight());
//            canvas.setSize(displayMode.getWidth(), displayMode.getHeight());
//        } else {
            window.pack();
//            window.setResizable(false);
//        }
        while (!canvas.isDisplayable()) {
            try {
                Thread.sleep(50);
            } catch (InterruptedException e) {}
        }
        gl = canvas.getGL();
        OpenGlGdp.hDC = canvas;
        OpenGlGdp.hDC.swapBuffers(); //TMP
        return true;
    }
    
//    public static void OGL_AddTriangle(float[] vtx1, float[] c1, float[] tex1, float[] vtx2, float[] c2, float[] tex2, float[] vtx3, float[] c3, float[] tex3) {
//        final int VTX = 0;
//        final int CLR = 1;
//        final int TEX = 2;
//        float[][][] v = {{vtx1, c1, tex1}, {vtx2, c2, tex2}, {vtx3, c3, tex3}};
//        
//        if (Rsp.gsp.changed != 0 || Rsp.gdp.changed != 0) {
//            OGL_GspUpdateStates();
//            OpenGlGdp.OGL_GdpUpdateStates();
//        }
//
//        for (int i = 0; i < 3; i++) {
//            float[][] spvert = v[i];
//            GLVertex vertex = vertices[numVertices];
//            vertex.vtx.put(0, spvert[VTX][0]);
//            vertex.vtx.put(1, spvert[VTX][1]);
//            vertex.vtx.put(2, Rsp.gdp.otherMode.depthSource == Gbi.G_ZS_PRIM ? OpenGlGdp.zDepth * spvert[VTX][3] : spvert[VTX][2]);
//            vertex.vtx.put(3, spvert[VTX][3]);
//            
//            vertex.color.put(0, spvert[CLR][0]);
//            vertex.color.put(1, spvert[CLR][1]);
//            vertex.color.put(2, spvert[CLR][2]);
//            vertex.color.put(3, spvert[CLR][3]);
//            OpenGlGdp.combiners.setConstant(vertex.color, OpenGlGdp.combiners.vertex.color, OpenGlGdp.combiners.vertex.alpha);
//            
//            if (OpenGlGdp.EXT_secondary_color) {
//                vertex.secondaryColor.put(0, 0.0f);
//                vertex.secondaryColor.put(0, 0.0f);
//                vertex.secondaryColor.put(0, 0.0f);
//                vertex.secondaryColor.put(0, 1.0f);
//                OpenGlGdp.combiners.setConstant(vertex.secondaryColor, OpenGlGdp.combiners.vertex.secondaryColor, Combiners.ONE);
//            }
//            
////            if ((Rsp.gsp.geometryMode & Gbi.G_FOG) != 0 && EXT_fog_coord && fog) {
////                if (spvert[VTX][2] < -spvert[VTX][3])
////                    vertex.fog.put(0, StrictMath.max(0.0f, -(float)Rsp.gsp.fog.multiplier + (float)Rsp.gsp.fog.offset));
////                else
////                    vertex.fog.put(0, StrictMath.max(0.0f, spvert[VTX][2] / spvert[VTX][3] * (float)Rsp.gsp.fog.multiplier + (float)Rsp.gsp.fog.offset));
////            }
//            
//            if (OpenGlGdp.combiners.usesT0) {
//                vertex.tex0.put(0, OpenGlGdp.cache.getTexS(0, spvert[TEX][0]));
//                vertex.tex0.put(1, OpenGlGdp.cache.getTexT(0, spvert[TEX][1]));
//            }
//            if (OpenGlGdp.combiners.usesT1) {
//                vertex.tex1.put(0, OpenGlGdp.cache.getTexS(1, spvert[TEX][0]));
//                vertex.tex1.put(1, OpenGlGdp.cache.getTexT(1, spvert[TEX][1]));
//            }
//            numVertices++;
//        }
//        
//        numTriangles++;
//        
//        if (numVertices >= 255)
//            OGL_DrawTriangles();
//    }
    
//    // called by Gsp
//    public static void OGL_AddTriangle(SPVertex[] spVertices, int v0, int v1, int v2) {
//        int v[] = {v0, v1, v2};
//        
//        if (Rsp.gsp.changed != 0 || Rsp.gdp.changed != 0) {
//            OGL_GspUpdateStates();
//            OpenGlGdp.OGL_GdpUpdateStates();
//        }
//
//        for (int i = 0; i < 3; i++) {
//            int index = v[i];
//            GLVertex vertex = vertices[numVertices];
//            vertex.vtx.put(0, spVertices[index].vtx[0]);
//            vertex.vtx.put(1, spVertices[index].vtx[1]);
//            vertex.vtx.put(2, Rsp.gdp.otherMode.depthSource == Gbi.G_ZS_PRIM ? OpenGlGdp.zDepth * spVertices[index].vtx[3] : spVertices[index].vtx[2]);
//            vertex.vtx.put(3, spVertices[index].vtx[3]);
//            
//            vertex.color.put(0, spVertices[index].color[0]);
//            vertex.color.put(1, spVertices[index].color[1]);
//            vertex.color.put(2, spVertices[index].color[2]);
//            vertex.color.put(3, spVertices[index].color[3]);
//            OpenGlGdp.combiners.setConstant(vertex.color, OpenGlGdp.combiners.vertex.color, OpenGlGdp.combiners.vertex.alpha);
//            
//            if (OpenGlGdp.EXT_secondary_color) {
//                vertex.secondaryColor.put(0, 0.0f);
//                vertex.secondaryColor.put(0, 0.0f);
//                vertex.secondaryColor.put(0, 0.0f);
//                vertex.secondaryColor.put(0, 1.0f);
//                OpenGlGdp.combiners.setConstant(vertex.secondaryColor, OpenGlGdp.combiners.vertex.secondaryColor, Combiners.ONE);
//            }
//            
////            if ((Rsp.gsp.geometryMode & Gbi.G_FOG) != 0 && EXT_fog_coord && fog) {
////                if (spVertices[index].vtx[2] < -spVertices[index].vtx[3])
////                    vertex.fog.put(0, StrictMath.max(0.0f, -(float)Rsp.gsp.fog.multiplier + (float)Rsp.gsp.fog.offset));
////                else
////                    vertex.fog.put(0, StrictMath.max(0.0f, spVertices[index].vtx[2] / spVertices[index].vtx[3] * (float)Rsp.gsp.fog.multiplier + (float)Rsp.gsp.fog.offset));
////            }
//            
//            if (OpenGlGdp.combiners.usesT0) {
//                vertex.tex0.put(0, OpenGlGdp.cache.getTexS(0, spVertices[index].tex[0]));
//                vertex.tex0.put(1, OpenGlGdp.cache.getTexT(0, spVertices[index].tex[1]));
//            }
//            if (OpenGlGdp.combiners.usesT1) {
//                vertex.tex1.put(0, OpenGlGdp.cache.getTexS(1, spVertices[index].tex[0]));
//                vertex.tex1.put(1, OpenGlGdp.cache.getTexT(1, spVertices[index].tex[1]));
//            }
//            numVertices++;
//        }
//        numTriangles++;
//        
//        if (numVertices >= 255)
//            OGL_DrawTriangles();
//    }
    
//    // called by Gsp
//    public static void OGL_DrawTriangles() {
//        OpenGlGdp.stipple();
//        gl.glDrawArrays(GL.GL_TRIANGLES, 0, numVertices);
//        numTriangles = numVertices = 0;
//    }
    
//    // called by Gsp
//    public static void OGL_DrawLine(float[] vtx1, float[] c1, float[] vtx2, float[] c2, float width) {
////        int v[] = {v0, v1};
//        final int VTX = 0;
//        final int CLR = 1;
//        float[][][] v = {{vtx1, c1}, {vtx2, c2}};
//        
//        float[] color = new float[4];
//        
//        if (Rsp.gsp.changed != 0 || Rsp.gdp.changed != 0) {
//            OGL_GspUpdateStates();
//            OpenGlGdp.OGL_GdpUpdateStates();
//        }
//        
//        gl.glLineWidth(width * OpenGlGdp.scaleX);
//        
//        gl.glBegin(GL.GL_LINES);
//        for (int i = 0; i < 2; i++) {
//            float[][] spvert = v[i];
//            color[0] = spvert[CLR][0];
//            color[1] = spvert[CLR][1];
//            color[2] = spvert[CLR][2];
//            color[3] = spvert[CLR][3];
//            OpenGlGdp.combiners.setConstant(color, OpenGlGdp.combiners.vertex.color, OpenGlGdp.combiners.vertex.alpha);
//            gl.glColor4fv(color, 0);
//            
//            if (OpenGlGdp.EXT_secondary_color) {
//                color[0] = spvert[CLR][0];
//                color[1] = spvert[CLR][1];
//                color[2] = spvert[CLR][2];
//                color[3] = spvert[CLR][3];
//                OpenGlGdp.combiners.setConstant(color, OpenGlGdp.combiners.vertex.secondaryColor, OpenGlGdp.combiners.vertex.alpha);
//                gl.glSecondaryColor3fvEXT(color, 0);
//            }
//            
//            gl.glVertex4f(spvert[VTX][0], spvert[VTX][1], spvert[VTX][2], spvert[VTX][3]);
//        }
//        gl.glEnd();
//    }
    
//    // called by Gsp
//    public static void OGL_DrawLine(SPVertex[] spVertices, int v0, int v1, float width) {
//        int v[] = {v0, v1};
//        
//        float[] color = new float[4];
//        
//        if (Rsp.gsp.changed != 0 || Rsp.gdp.changed != 0) {
//            OGL_GspUpdateStates();
//            OpenGlGdp.OGL_GdpUpdateStates();
//        }
//        
//        gl.glLineWidth(width * OpenGlGdp.scaleX);
//        
//        gl.glBegin(GL.GL_LINES);
//        for (int i = 0; i < 2; i++) {
//            color[0] = spVertices[v[i]].color[0];
//            color[1] = spVertices[v[i]].color[1];
//            color[2] = spVertices[v[i]].color[2];
//            color[3] = spVertices[v[i]].color[3];
//            OpenGlGdp.combiners.setConstant(color, OpenGlGdp.combiners.vertex.color, OpenGlGdp.combiners.vertex.alpha);
//            gl.glColor4fv(color, 0);
//            
//            if (OpenGlGdp.EXT_secondary_color) {
//                color[0] = spVertices[v[i]].color[0];
//                color[1] = spVertices[v[i]].color[1];
//                color[2] = spVertices[v[i]].color[2];
//                color[3] = spVertices[v[i]].color[3];
//                OpenGlGdp.combiners.setConstant(color, OpenGlGdp.combiners.vertex.secondaryColor, OpenGlGdp.combiners.vertex.alpha);
//                gl.glSecondaryColor3fvEXT(color, 0);
//            }
//            
//            gl.glVertex4f(spVertices[v[i]].vtx[0], spVertices[v[i]].vtx[1], spVertices[v[i]].vtx[2], spVertices[v[i]].vtx[3]);
//        }
//        gl.glEnd();
//    }

    // Private Methods /////////////////////////////////////////////////////////
    
    private static void OGL_UpdateCullFace() {
        if ((Rsp.gsp.geometryMode & Gbi.G_CULL_BOTH)!=0) {
            gl.glEnable(GL.GL_CULL_FACE);
            
            if ((Rsp.gsp.geometryMode & Gbi.G_CULL_BACK)!=0)
                gl.glCullFace(GL.GL_BACK);
            else
                gl.glCullFace(GL.GL_FRONT);
        } else
            gl.glDisable(GL.GL_CULL_FACE);
    }
    
    public static void OGL_GspUpdateStates() {
        if ((Rsp.gsp.changed & Gsp.CHANGED_GEOMETRYMODE) != 0) {
            OGL_UpdateCullFace();
//            if ((Rsp.gsp.geometryMode & Gbi.G_FOG)!=0 && EXT_fog_coord && fog)
//                gl.glEnable(GL.GL_FOG);
//            else
                gl.glDisable(GL.GL_FOG);
            Rsp.gsp.changed &= ~Gsp.CHANGED_GEOMETRYMODE;
        }
        
        if ((Rsp.gsp.geometryMode & Gbi.G_ZBUFFER) != 0)
            gl.glEnable(GL.GL_DEPTH_TEST);
        else
            gl.glDisable(GL.GL_DEPTH_TEST);
        
        Rsp.gsp.changed &= Gsp.CHANGED_MATRIX;
    }
    
}
