/**
 * Copyright 2005 Jason LaDere
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Originally based on Project64 code.
 *
 */

/*
 * GDP.java
 *
 * Created on November 26, 2005, 8:51 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package gln64j.rdp;

import gln64j.OpenGlGdp;
import gln64j.Registers;
import gln64j.Gbi;
import gln64j.rdp.combiners.Combiners;

/**
 *
 * @author Jason
 */
public class Gdp {
    
    public static final int CHANGED_RENDERMODE=		0x001;
    public static final int CHANGED_CYCLETYPE=		0x002;
    public static final int CHANGED_SCISSOR=		0x004;
    public static final int CHANGED_COLORBUFFER =	0x008;
    public static final int CHANGED_TILE=		0x010;
    public static final int CHANGED_COMBINE_COLORS=     0x020;
    public static final int CHANGED_COMBINE=		0x040;
    public static final int CHANGED_ALPHACOMPARE=       0x080;
    public static final int CHANGED_FOGCOLOR=		0x100;
    public static final int CHANGED_TEXTURE=            0x200;
    public static final int CHANGED_VIEWPORT =		0x400;
    
    public static class OtherMode {
        public int w0; // high
        public int w1; // low
        
//        // L (32)
//        public int alphaCompare; //: 2;
//        public int depthSource; //: 1;
//        // RenderMode
//        public int AAEnable; //: 1;
//        public int depthCompare; //: 1;
//        public int depthUpdate; //: 1;
//        public int imageRead; //: 1;
//        public int clearOnCvg; //: 1;
//        public int cvgDest; //: 2;
//        public int depthMode; //: 2;
//        public int cvgXAlpha; //: 1;
//        public int alphaCvgSel; //: 1;
//        public int forceBlender; //: 1;
//        public int textureEdge; //: 1;
//        // Blender
//        public int c2_m2b; //: 2;
//        public int c1_m2b; //: 2;
//        public int c2_m2a; //: 2;
//        public int c1_m2a; //: 2;
//        public int c2_m1b; //: 2;
//        public int c1_m1b; //: 2;
//        public int c2_m1a; //: 2;
//        public int c1_m1a; //: 2;
//        
//        // H (32)
//        public int blendMask; //: 4;
//        public int alphaDither; //: 2;
//        public int colorDither; //: 2;
//        public int combineKey; //: 1;
//        public int textureConvert; //: 3;
//        public int textureFilter; //: 2;
//        public int textureLUT; //: 2;
//        public int textureLOD; //: 1;
//        public int textureDetail; //: 2;
//        public int texturePersp; //: 1;
//        public int cycleType; //: 2;
//        public int unusedColorDither; //: 1; // unsupported
//        public int pipelineMode; //: 1;
//        public int pad; // : 8;
//        
//        public void setL(int value) {
//            c1_m1a = (value>>30)&3;
//            c2_m1a = (value>>28)&3;
//            c1_m1b = (value>>26)&3;
//            c2_m1b = (value>>24)&3;
//            c1_m2a = (value>>22)&3;
//            c2_m2a = (value>>20)&3;
//            c1_m2b = (value>>18)&3;
//            c2_m2b = (value>>16)&3;
//            textureEdge = (value>>15)&1;
//            forceBlender = (value>>14)&1;
//            alphaCvgSel = (value>>13)&1;
//            cvgXAlpha = (value>>12)&1;
//            depthMode = (value>>10)&3;
//            cvgDest = (value>>8)&3;
//            clearOnCvg = (value>>7)&1;
//            imageRead = (value>>6)&1;
//            depthUpdate = (value>>5)&1;
//            depthCompare = (value>>4)&1;
//            AAEnable = (value>>3)&1;
//            depthSource = (value>>2)&1;
//            alphaCompare = (value)&3;
//        }
//        
//        public int getL() {
//            return ((c1_m1a&3)<<30) | ((c2_m1a&3)<<28) | ((c1_m1b&3)<<26)
//            | ((c2_m1b&3)<<24) | ((c1_m2a&3)<<22) | ((c2_m2a&3)<<20)
//            | ((c1_m2b&3)<<18) | ((c2_m2b&3)<<16) | ((textureEdge&1)<<15)
//            | ((forceBlender&1)<<14) | ((alphaCvgSel&1)<<13) | ((cvgXAlpha&1)<<12)
//            | ((depthMode&3)<<10) | ((cvgDest&3)<<8) | ((clearOnCvg&1)<<7) | ((imageRead&1)<<6)
//            | ((depthUpdate&1)<<5) | ((depthCompare&1)<<4) | ((AAEnable&1)<<3) | ((depthSource&1)<<2)
//            | (alphaCompare&3);
//        }
//        
//        public void setH(int value) {
//            pad = (value>>24)&0xFF;
//            pipelineMode = (value>>23)&1;
//            unusedColorDither = (value>>22)&1;
//            cycleType = (value>>20)&3;
//            texturePersp = (value>>19)&1;
//            textureDetail = (value>>17)&3;
//            textureLOD = (value>>15)&1;
//            textureLUT = (value>>14)&3;
//            textureFilter = (value>>12)&3;
//            textureConvert = (value>>9)&7;
//            combineKey = (value>>8)&1;
//            colorDither = (value>>6)&3;
//            alphaDither = (value>>4)&3;
//            blendMask = (value)&15;
//        }
//        
//        public int getH() {
//            return ((pad&0xFF)<<24) | ((pipelineMode&1)<<23) | ((unusedColorDither&1)<<22)
//            | ((cycleType&3)<<20) | ((texturePersp&1)<<19) | ((textureDetail&3)<<17)
//            | ((textureLOD&1)<<16) | ((textureLUT&3)<<14) | ((textureFilter&3)<<12)
//            | ((textureConvert&7)<<9) | ((combineKey&1)<<8) | ((colorDither&3)<<6)
//            | ((alphaDither&3)<<4) | (blendMask&15);
//        }
    };
    
    public static final int PIPELINE_MODE = 0x800000;
    public static final int CYCLE_TYPE = 0x300000;
    public static final int TEX_PERSP = 0x80000;
    public static final int TEX_DETAIL = 0x60000;
    public static final int TEX_LOD = 0x10000;
    public static final int TEX_LUT = 0xC000;
    public static final int TEX_FILTER = 0x3000;
    public static final int TEX_CONVERT = 0xE00;
    public static final int COMBINE_KEY = 0x100;
    public static final int COLOR_DITHER = 0xC0;
    public static final int ALPHA_DITHER = 0x30;
    public static final int DEPTH_SOURCE = 0x4;
    public static final int ALPHA_COMPARE = 0x3;
    
public static final int RDP_GETOM_CYCLE_TYPE(OtherMode om) {return(((om).w0 >> 20) & 0x3);}
//public static final int RDP_GETOM_PERSP_TEX_EN(OtherMode om) {return(((om).w0 & 0x80000)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_DETAIL_TEX_EN(OtherMode om) {return(((om).w0 & 0x40000)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_SHARPEN_TEX_EN(OtherMode om) {return(((om).w0 & 0x20000)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_TEX_LOD_EN(OtherMode om) {return(((om).w0 & 0x10000)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_EN_TLUT(OtherMode om) {return(((om).w0 & 0x08000)!=0 ? 1 : 0);}
public static final int RDP_GETOM_TLUT_TYPE(OtherMode om) {return(((om).w0 >> 14) & 0x3);}//& 0x04000)!=0 ? 1 : 0);}
public static final int RDP_GETOM_SAMPLE_TYPE(OtherMode om) {return(((om).w0 >> 12) & 0x3);}//& 0x02000)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_MID_TEXEL(OtherMode om) {return(((om).w0 & 0x01000)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_BI_LERP0(OtherMode om) {return(((om).w0 & 0x00800)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_BI_LERP1(OtherMode om) {return(((om).w0 & 0x00400)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_CONVERT_ONE(OtherMode om) {return(((om).w0 & 0x00200)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_KEY_EN(OtherMode om) {return(((om).w0 & 0x00100)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_RGB_DITHER_SEL(OtherMode om) {return(((om).w0 >> 6) & 0x3);}
//public static final int RDP_GETOM_ALPHA_DITHER_SEL(OtherMode om) {return(((om).w0 >> 4) & 0x3);}
//public static final int RDP_GETOM_BLEND_M1A_0(OtherMode om) {return(((om).w1 >> 30) & 0x3);}
//public static final int RDP_GETOM_BLEND_M1A_1(OtherMode om) {return(((om).w1 >> 28) & 0x3);}
//public static final int RDP_GETOM_BLEND_M1B_0(OtherMode om) {return(((om).w1 >> 26) & 0x3);}
//public static final int RDP_GETOM_BLEND_M1B_1(OtherMode om) {return(((om).w1 >> 24) & 0x3);}
//public static final int RDP_GETOM_BLEND_M2A_0(OtherMode om) {return(((om).w1 >> 22) & 0x3);}
//public static final int RDP_GETOM_BLEND_M2A_1(OtherMode om) {return(((om).w1 >> 20) & 0x3);}
//public static final int RDP_GETOM_BLEND_M2B_0(OtherMode om) {return(((om).w1 >> 18) & 0x3);}
//public static final int RDP_GETOM_BLEND_M2B_1(OtherMode om) {return(((om).w1 >> 16) & 0x3);}
public static final int RDP_GETOM_FORCE_BLEND(OtherMode om) {return(((om).w1 & 0x4000)!=0 ? 1 : 0);}
public static final int RDP_GETOM_ALPHA_CVG_SELECT(OtherMode om) {return(((om).w1 & 0x2000)!=0 ? 1 : 0);}
public static final int RDP_GETOM_CVG_TIMES_ALPHA(OtherMode om) {return(((om).w1 & 0x1000)!=0 ? 1 : 0);}
public static final int RDP_GETOM_Z_MODE(OtherMode om) {return(((om).w1 >> 10) & 0x3);}
//public static final int RDP_GETOM_CVG_DEST(OtherMode om) {return(((om).w1 >> 8) & 0x3);}
//public static final int RDP_GETOM_COLOR_ON_CVG(OtherMode om) {return(((om).w1 & 0x80)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_IMAGE_READ_EN(OtherMode om) {return(((om).w1 & 0x40)!=0 ? 1 : 0);}
public static final int RDP_GETOM_Z_UPDATE_EN(OtherMode om) {return(((om).w1 & 0x20)!=0 ? 1 : 0);}
public static final int RDP_GETOM_Z_COMPARE_EN(OtherMode om) {return(((om).w1 & 0x10)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_ANTIALIAS_EN(OtherMode om) {return(((om).w1 & 0x08)!=0 ? 1 : 0);}
public static final int RDP_GETOM_Z_SOURCE_SEL(OtherMode om) {return(((om).w1 & 0x04)!=0 ? 1 : 0);}
//public static final int RDP_GETOM_DITHER_ALPHA_EN(OtherMode om) {return(((om).w1 & 0x02)!=0 ? 1 : 0);}
public static final int RDP_GETOM_ALPHA_COMPARE_EN(OtherMode om) {return(((om).w1 >> 0) & 0x3);}//& 0x01)!=0 ? 1 : 0);}

    
    public static class FillColor {
        public float[] color = new float[4];
        public float z;
        public float dz;
    };
    
    public static class PrimDepth {
        public float z;
        public float deltaZ;
    };
    
    public static class ColorImage {
        public int format;
        public int size;
        public int width;
        public int height;
        public int bpl;
        public int address;
        public boolean changed;
        public int depthImage;
    };
    
    public static class Scissor {
        public int mode;
        public float ulx;
        public float uly;
        public float lrx;
        public float lry;
    };
    
    public static class Convert {
        public int k0;
        public int k1;
        public int k2;
        public int k3;
        public int k4;
        public int k5;
    };
    
    public static class Key {
        public float[] center = new float[4];
        public float[] scale = new float[4];
        public float[] width = new float[4];
    };
    
    // used by Gsp.processDlist
    public int DList;
    // used by OpenGl.offsetFill/addTriangle, OpenGlGdp, Opcodes
    public OtherMode otherMode = new OtherMode();
    // used by OpenGL.init/addTriangle/drawLine, OpenGlGdp, Opcodes
    public int changed;
    // used by OpenGlGdp.updateStates
    public float[] fogColor = new float[4];
    public float[] blendColor = new float[4];
    public Scissor scissor = new Scissor();
    // used by OpenGlGdp.viUpdateScreen
    public ColorImage colorImage = new ColorImage();
    
    protected PrimDepth primDepth = new PrimDepth();
    protected DepthBufferStack depthBuffers = new DepthBufferStack();
    protected DepthBufferStack.DepthBuffer current;
    protected int depthImageAddress;
//    protected Convert convert = new Convert();
//    protected Key key = new Key();
    protected FillColor fillColor = new FillColor();
    protected Runnable checkInterrupts;
    protected Registers reg;
    
    /** Creates a new instance of GDP */
    public Gdp(Runnable checkInterrupts, Registers regs) {
        this.checkInterrupts = checkInterrupts;
        this.reg = regs;
        
        OpenGlGdp.cache.construct();
        
        current = null;
        depthBuffers.init();
    }
    
    // called by F3d, F3dex2
    public void gDPTexture(float sc, float tc, int level, int tile, int on) {
        OpenGlGdp.cache.setTexture(sc, tc, level, tile, on);
        changed |= CHANGED_TEXTURE;
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPPipelineMode(int mode) {
//        otherMode.pipelineMode = mode & 0x1;
        otherMode.w0 &= ~PIPELINE_MODE;
        otherMode.w0 |= ((mode & 0x1) << 23);
        
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetCycleType(int type) {
//        otherMode.cycleType = type & 0x3;
        otherMode.w0 &= ~CYCLE_TYPE;
        otherMode.w0 |= ((type & 0x3) << 20);
        changed |= CHANGED_CYCLETYPE;
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetTexturePersp(int enable) {
//        otherMode.texturePersp = enable & 0x1;
        otherMode.w0 &= ~TEX_PERSP;
        otherMode.w0 |= ((enable & 0x1) << 19);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetTextureDetail(int type) {
//        otherMode.textureDetail = type & 0x3;
        otherMode.w0 &= ~TEX_DETAIL;
        otherMode.w0 |= ((type & 0x3) << 17);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetTextureLOD(int mode) {
//        otherMode.textureLOD = mode & 0x1;
        otherMode.w0 &= ~TEX_LOD;
        otherMode.w0 |= ((mode & 0x1) << 16);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetTextureLUT(int mode) {
//        otherMode.textureLUT = mode & 0x3;
        otherMode.w0 &= ~TEX_LUT;
        otherMode.w0 |= ((mode & 0x3) << 14);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetTextureFilter(int type) {
//        otherMode.textureFilter = type & 0x3;
        otherMode.w0 &= ~TEX_FILTER;
        otherMode.w0 |= ((type & 0x3) << 12);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetTextureConvert(int type) {
//        otherMode.textureConvert = type & 0x7;
        otherMode.w0 &= ~TEX_CONVERT;
        otherMode.w0 |= ((type & 0x7) << 9);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetCombineKey(int type) {
//        otherMode.combineKey = type & 0x1;
        otherMode.w0 &= ~COMBINE_KEY;
        otherMode.w0 |= ((type & 0x1) << 8);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetColorDither(int type) {
//        otherMode.colorDither = type & 0x3;
        otherMode.w0 &= ~COLOR_DITHER;
        otherMode.w0 |= ((type & 0x3) << 6);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetAlphaDither(int type) {
//        otherMode.alphaDither = type & 0x3;
        otherMode.w0 &= ~ALPHA_DITHER;
        otherMode.w0 |= ((type & 0x3) << 4);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetAlphaCompare(int mode) {
//        otherMode.alphaCompare = mode & 0x3;
        otherMode.w1 &= ~ALPHA_COMPARE;
        otherMode.w1 |= ((mode & 0x3) << 0);
        changed |= CHANGED_ALPHACOMPARE;
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetDepthSource(int source) {
//        otherMode.depthSource = source & 0x1;
        otherMode.w1 &= ~DEPTH_SOURCE;
        otherMode.w1 |= ((source & 0x1) << 2);
    }
    
    // called by Rsp, F3d, F3dex2
    public void gDPSetRenderMode(int mode1, int mode2) {
//        otherMode.setL(otherMode.getL() & 0x00000007);
//        otherMode.setL(otherMode.getL() | mode1 | mode2);
        otherMode.w1 = (otherMode.w1 & 0x00000007);
        otherMode.w1 = (otherMode.w1 | mode1 | mode2);
        changed |= CHANGED_RENDERMODE;
    }
    
    //////////////////////////////////////////////////////////////
    
    // called by Rdp
    public void gDPSetOtherMode(int mode0, int mode1) {
        // mode0 rdpState.otherModes.w1
        // mode1 rdpState.otherModes.w2
//        otherMode.setH(mode0);
//        otherMode.setL(mode1);
        otherMode.w0 = mode0;
        otherMode.w1 = mode1;
        changed |= CHANGED_RENDERMODE | CHANGED_CYCLETYPE | CHANGED_ALPHACOMPARE;
    }
    
    // called by Rdp
    public void gDPSetPrimDepth(int z, int dz) {
        // z rdpState.primitiveZ (0xfff)
        // dz rdpState.primitiveDeltaZ (w1 & 0xfff)
        primDepth.z = z;
        primDepth.deltaZ = dz;
        OpenGlGdp.setZDepth(z);
    }
    
    // called by Rdp
    public void gDPSetCombine(int muxs0, int muxs1) {
        // muxs0 rdpState.combineModes.w1
        // muxs1 rdpState.combineModes.w2
        OpenGlGdp.combiners.combine.setMuxs0(muxs0);
        OpenGlGdp.combiners.combine.setMuxs1(muxs1);
        changed |= CHANGED_COMBINE;
    }
    
    // called by Rdp
    public void gDPSetColorImage(int format, int size, int width, int address) {
        // rdpFbFormat
        // rdpFbSize
        // rdpFbWidth (0x3ff)
        // rdpFbAddress (w2 & 0x01ffffff)
        if (colorImage.address != address) {
            colorImage.changed = false;
            
            if (width == OpenGlGdp.screenWidth)
                colorImage.height = OpenGlGdp.screenHeight;
            else
                colorImage.height = 1;
        }
        
        colorImage.format = format;
        colorImage.size = size;
        colorImage.width = width;
        colorImage.address = address;
    }
    
    // called by Rdp
    public void gDPSetTextureImage(int format, int size, int width, int address) {
        // rdpTiFormat
        // rdpTiSize
        // rdpTiWidth (0x3ff)
        // rdpTiAddress (w2 & 0x01ffffff)
        OpenGlGdp.cache.setTextureImage(format, size, width, address);
    }
    
    // called by Rdp
    public void gDPSetDepthImage(int address) {
        // rdpZbAddress (w2 & 0x01ffffff)
//        setBuffer(address);
        DepthBufferStack.DepthBuffer buffer = depthBuffers.top;
        // Search through saved depth buffers
        while (buffer != null) {
            if (buffer.address == address) {
                depthBuffers.moveToTop(buffer);
                current = buffer;
                return;
            }
            buffer = buffer.lower;
        }
        buffer = new DepthBufferStack.DepthBuffer();
        depthBuffers.addTop(buffer);
        buffer.address = address;
        buffer.cleared = true;
        current = buffer;
        if (current.cleared)
//            OpenGlGdp.OGL_ClearDepthBuffer(otherMode.depthUpdate != 0);
            OpenGlGdp.OGL_ClearDepthBuffer(RDP_GETOM_Z_UPDATE_EN(otherMode) != 0);
        depthImageAddress = address;
    }
    
//    private void setBuffer(int address) {
//        DepthBufferStack.DepthBuffer buffer = depthBuffers.top;
//        // Search through saved depth buffers
//        while (buffer != null) {
//            if (buffer.address == address) {
//                depthBuffers.moveToTop(buffer);
//                current = buffer;
//                return;
//            }
//            buffer = buffer.lower;
//        }
//        buffer = new DepthBufferStack.DepthBuffer();
//        depthBuffers.addTop(buffer);
//        buffer.address = address;
//        buffer.cleared = true;
//        current = buffer;
//    }
    
    // called by Rdp
    public void gDPSetEnvColor(int r, int g, int b, int a) {
        // rdpState.envColor = w2 r|g|b|a;
        Combiners.envColor[0] = r * 0.0039215689f; // r / 255
        Combiners.envColor[1] = g * 0.0039215689f; // g / 255
        Combiners.envColor[2] = b * 0.0039215689f; // b / 255
        Combiners.envColor[3] = a * 0.0039215689f; // a / 255
        changed |= CHANGED_COMBINE_COLORS;
    }
    
    // called by Rdp
    public void gDPSetBlendColor(int r, int g, int b, int a) {
        // rdpState.blendColor = w2; r|g|b|a
        blendColor[0] = r * 0.0039215689f; // r / 255
        blendColor[1] = g * 0.0039215689f; // g / 255
        blendColor[2] = b * 0.0039215689f; // b / 255
        blendColor[3] = a * 0.0039215689f; // a / 255
    }
    
    // called by Rdp
    public void gDPSetFogColor(int r, int g, int b, int a) {
        //rdpState.fogColor = w2; r|g|b|a
        fogColor[0] = r * 0.0039215689f; // r / 255
        fogColor[1] = g * 0.0039215689f; // g / 255
        fogColor[2] = b * 0.0039215689f; // b / 255
        fogColor[3] = a * 0.0039215689f; // a / 255
        changed |= CHANGED_FOGCOLOR;
    }
    
    // called by Rdp
    public void gDPSetFillColor(int c) {
        // rdpState.fillColor
        fillColor.color[0] = ((c >> 11) & 0x1f) * 0.032258064f;
        fillColor.color[1] = ((c >> 6) & 0x1f) * 0.032258064f;
        fillColor.color[2] = ((c >> 1) & 0x1f) * 0.032258064f;
        fillColor.color[3] = c & 0x1;
        fillColor.z = (c >> 2) & 0x3fff;
        fillColor.dz = c & 0x3;
    }
    
    // called by Rdp
    public void gDPSetPrimColor(int m, int l, int r, int g, int b, int a) {
        // rdpState.primColor = w2; r|g|b|a
        Combiners.primColor.m = m;
        Combiners.primColor.l = l * 0.0039215689f; // l / 255
        Combiners.primColor.r = r * 0.0039215689f; // r / 255
        Combiners.primColor.g = g * 0.0039215689f; // g / 255
        Combiners.primColor.b = b * 0.0039215689f; // b / 255
        Combiners.primColor.a = a * 0.0039215689f; // a / 255
        changed |= CHANGED_COMBINE_COLORS;
    }
    
    // called by Rdp
    public void gDPSetTile(int format, int size, int line, int tmem, int tilenum, int palette, int cmt, int cms, int maskt, int masks, int shiftt, int shifts) {
        // rdpTiles[tilenum]
        // format
        // size
        // line / 8
        // tmem / 8
        // tilenum
        // palette
        // mt/ct ((w2 >> 18) & 0x1) | ((w2 >> 19) & 0x1)
        // ms/cs ((w2 >> 8) & 0x1) | ((w2 >> 9) & 0x1)
        // mask_t
        // mask_s
        // shift_t
        // shift_s
        OpenGlGdp.cache.setTile(format, size, line, tmem, tilenum, palette, cmt, cms, maskt, masks, shiftt, shifts);
    }
    
    // called by Rdp
    public void gDPSetTileSize(int tilenum, int uls, int ult, int lrs, int lrt) {
        // rdpTiles[tilenum]
        // tilenum
        // uls sl
        // ult tl
        // lrs sh
        // lrt th
        OpenGlGdp.cache.setTileSize(tilenum,
                (uls >> 2) & 0x3ff,
                (ult >> 2) & 0x3ff,
                (lrs >> 2) & 0x3ff,
                (lrt >> 2) & 0x3ff,
                uls * 0.25f,  // uls / 4
                ult * 0.25f,  // ult / 4
                lrs * 0.25f,  // lrs / 4
                lrt * 0.25f); // lrt / 4
        changed |= CHANGED_TILE;
    }
    
    // called by Rdp
    public void gDPLoadTile(int tilenum, int uls, int ult, int lrs, int lrt) {
        // tilenum
        // uls sl * 4
        // ult tl * 4
        // lrs sh * 4
        // lrt th * 4
        gDPSetTileSize(tilenum, uls, ult, lrs, lrt);
        OpenGlGdp.cache.loadTile(tilenum);
    }
    
    // called by Rdp
    public void gDPLoadBlock(int tilenum, int uls, int ult, int lrs, int dxt) {
        // tilenum
        // uls sl
        // ult tl >> 11
        // lrs sh
        // dxt
        gDPSetTileSize(tilenum, uls, ult, lrs, dxt);
        OpenGlGdp.cache.loadBlock(tilenum, uls, ult, lrs, dxt);
    }
    
    // called by Rdp
    public void gDPLoadTLUT(int tilenum, int uls, int ult, int lrs, int lrt) {
        // rdpTiles[tilenum]
        // tilenum
        // uls sl
        // ult tl
        // lrs sh
        // lrt th
        gDPSetTileSize(tilenum, uls, ult, lrs, lrt);
        OpenGlGdp.cache.loadLUT(tilenum);
    }
    
    // called by Rdp
    public void gDPSetScissor(int mode, float ulx, float uly, float lrx, float lry) {
        // rdpState.clipMode
        // ulx rdpState.clip.xh * 4
        // uly rdpState.clip.yh * 4
        // lrx rdpState.clip.xl * 4
        // lry rdpState.clip.yl * 4
        scissor.mode = mode;
        scissor.ulx = ulx;
        scissor.uly = uly;
        scissor.lrx = lrx;
        scissor.lry = lry;
        changed |= CHANGED_SCISSOR;
    }
    
    // called by Rdp
    public void gDPFillRectangle(int ulx, int uly, int lrx, int lry) {
        // ulx rect.xh (w2 >> 12) & 0xfff
        // uly rect.yh (w2 >> 0) & 0xfff
        // lrx rect.xl (w1 >> 12) & 0xfff
        // lry rect.yl (w1 >> 0) & 0xfff
        DepthBufferStack.DepthBuffer buffer = depthBuffers.findBuffer(colorImage.address);
        
        if (buffer != null)
            buffer.cleared = true;
        
        if (depthImageAddress == colorImage.address) {
//            OpenGlGdp.OGL_ClearDepthBuffer(otherMode.depthUpdate != 0);
            OpenGlGdp.OGL_ClearDepthBuffer(RDP_GETOM_Z_UPDATE_EN(otherMode) != 0);
            return;
        }
        
//        if (otherMode.cycleType == Gbi.G_CYC_FILL) {
        if (RDP_GETOM_CYCLE_TYPE(otherMode) == Gbi.G_CYC_FILL) {
            lrx++;
            lry++;
            
            if ((ulx == 0) && (uly == 0) && (lrx == OpenGlGdp.screenWidth) && (lry == OpenGlGdp.screenHeight)) {
                OpenGlGdp.OGL_ClearColorBuffer(fillColor.color);
                return;
            }
        }
        
//        OpenGlGdp.OGL_DrawRect(ulx, uly, lrx, lry, (otherMode.cycleType==Gbi.G_CYC_FILL)?fillColor.color:blendColor, otherMode.depthSource);
        OpenGlGdp.OGL_DrawRect(ulx, uly, lrx, lry, (RDP_GETOM_CYCLE_TYPE(otherMode)==Gbi.G_CYC_FILL)?fillColor.color:blendColor, RDP_GETOM_Z_SOURCE_SEL(otherMode));
        
        // RDP function
        if (current != null)
            current.cleared = false;
        colorImage.changed = true;
        colorImage.height = StrictMath.max(colorImage.height, lry);
    }
    
    // called by Rdp
    public void gDPSetConvert(int k0, int k1, int k2, int k3, int k4, int k5) {
        // k5 rdpState.k5 (0xff)
//        convert.k0 = k0;
//        convert.k1 = k1;
//        convert.k2 = k2;
//        convert.k3 = k3;
//        convert.k4 = k4;
//        convert.k5 = k5;
    }
    
    // called by Rdp
    public void gDPSetKeyR(int cR, int sR, int wR) {
//        key.center[0] = cR * 0.0039215689f;
//        key.scale[0] = sR * 0.0039215689f;
//        key.width[0] = wR * 0.0039215689f;
    }
    
    // called by Rdp
    public void gDPSetKeyGB(int cG, int sG, int wG, int cB, int sB, int wB) {
//        key.center[1] = cG * 0.0039215689f;
//        key.scale[1] = sG * 0.0039215689f;
//        key.width[1] = wG * 0.0039215689f;
//        key.center[2] = cB * 0.0039215689f;
//        key.scale[2] = sB * 0.0039215689f;
//        key.width[2] = wB * 0.0039215689f;
    }
    
    public void update() {
        if (current != null)
            current.cleared = false;
        colorImage.changed = true;
        colorImage.height = (int)StrictMath.max(colorImage.height, scissor.lry);
    }
    
    // called by Rdp
    public void gDPTextureRectangle(float ulx, float uly, float lrx, float lry, int tilenum, float s, float t, float dsdx, float dtdy, boolean flip) {
        // ulx rect.xh * 4
        // uly rect.yh * 4
        // lrx rect.xl * 4
        // lry rect.yl * 4
        // rect.tilenum
        // s rect.s * 32
        // t rect.t * 32
        // dsdx rect.dsdx * 1024
        // dsdy rect.dtdy * 1024
//        if (otherMode.cycleType == Gbi.G_CYC_COPY) {
        if (RDP_GETOM_CYCLE_TYPE(otherMode) == Gbi.G_CYC_COPY) {
            dsdx = 1.0f;
            lrx += 1.0f;
            lry += 1.0f;
        }
        
        float lrs = s + (lrx - ulx - 1) * dsdx;
        float lrt = t + (lry - uly - 1) * dtdy;
        
        OpenGlGdp.cache.setTextureTile(lrs, lrt, tilenum, s, t, dsdx, dtdy);
        
        if (lrs > s) {
            if (lrt > t)
//                OpenGlGdp.OGL_DrawTexturedRect(ulx, uly, lrx, lry, s, t, lrs, lrt, flip, otherMode.depthSource, otherMode.cycleType);
                OpenGlGdp.OGL_DrawTexturedRect(ulx, uly, lrx, lry, s, t, lrs, lrt, flip, RDP_GETOM_Z_SOURCE_SEL(otherMode), RDP_GETOM_CYCLE_TYPE(otherMode));
            else
//                OpenGlGdp.OGL_DrawTexturedRect(ulx, lry, lrx, uly, s, lrt, lrs, t, flip, otherMode.depthSource, otherMode.cycleType);
                OpenGlGdp.OGL_DrawTexturedRect(ulx, lry, lrx, uly, s, lrt, lrs, t, flip, RDP_GETOM_Z_SOURCE_SEL(otherMode), RDP_GETOM_CYCLE_TYPE(otherMode));
        } else {
            if (lrt > t)
//                OpenGlGdp.OGL_DrawTexturedRect(lrx, uly, ulx, lry, lrs, t, s, lrt, flip, otherMode.depthSource, otherMode.cycleType);
                OpenGlGdp.OGL_DrawTexturedRect(lrx, uly, ulx, lry, lrs, t, s, lrt, flip, RDP_GETOM_Z_SOURCE_SEL(otherMode), RDP_GETOM_CYCLE_TYPE(otherMode));
            else
//                OpenGlGdp.OGL_DrawTexturedRect(lrx, lry, ulx, uly, lrs, lrt, s, t, flip, otherMode.depthSource, otherMode.cycleType);
                OpenGlGdp.OGL_DrawTexturedRect(lrx, lry, ulx, uly, lrs, lrt, s, t, flip, RDP_GETOM_Z_SOURCE_SEL(otherMode), RDP_GETOM_CYCLE_TYPE(otherMode));
        }
        
        OpenGlGdp.cache.resetTextureTile();
        
        if (current != null)
            current.cleared = false;
        colorImage.changed = true;
        colorImage.height = (int)StrictMath.max(colorImage.height, scissor.lry);
    }
    
    // called by Rdp
    public void gDPTextureRectangleFlip(float ulx, float uly, float lrx, float lry, int tilenum, float s, float t, float dsdx, float dtdy) {
        // ulx rect.xh * 4
        // uly rect.yh * 4
        // lrx rect.xl * 4
        // lry rect.yl * 4
        // rect.tilenum
        // s rect.t * 32
        // t rect.s * 32
        // dsdx rect.dtdy * 1024
        // dsdy rect.dsdx * 1024
        gDPTextureRectangle(ulx, uly, lrx, lry, tilenum, s + (lrx - ulx) * dsdx, t + (lry - uly) * dtdy, -dsdx, -dtdy, true);
    }
    
    // called by Rdp
    public void gDPFullSync() {
        reg.MI_Registers[reg.MI_INTR] |= Registers.MI_INTR_DP;
        checkInterrupts.run();
    }
    
    // called by Rdp
    public void gDPTileSync() {

    }
    
    // called by Rdp
    public void gDPPipeSync() {

    }
    
    // called by Rdp
    public void gDPLoadSync() {

    }
    
    // called by Rdp
    public void gDPNoOp() {

    }
    
}
